// ignore_for_file: public_member_api_docs
import "dart:ffi";

import "package:ffi/ffi.dart";

import "../enums/emarket_not_allowed_reason_flags.dart";
import "../typedefs.dart";

@Packed(8)
class MarketEligibilityResponse extends Struct {
  static int get callbackId => 166;

  @Bool()
  external bool allowed;

  @Int32()
  external EMarketNotAllowedReasonFlags notAllowedReason;

  @UnsignedInt()
  external RTime32 allowedAtTime;

  @Int()
  external int steamGuardRequiredDays;

  @Int()
  external int newDeviceCooldown;
}

extension MarketEligibilityResponseExtensions
    on Pointer<MarketEligibilityResponse> {
  bool get allowed => ref.allowed;

  EMarketNotAllowedReasonFlags get notAllowedReason => ref.notAllowedReason;

  RTime32 get allowedAtTime => ref.allowedAtTime;

  int get steamGuardRequiredDays => ref.steamGuardRequiredDays;

  int get newDeviceCooldown => ref.newDeviceCooldown;
}
